<template>
  <div class="container">
    <header class="jumbotron">
      <h3>
        Witaj <strong> {{ currentUser.username }}!</strong>
      </h3>
    </header>

    <div class="col-md-4 mb-3" v-if="content.toString().length < 3">
      <p><strong>Brak Twoich danych!</strong></p>
      <button class="btn btn-primary" v-on:click="addUserDetails()">Uzupełnij dane</button>
    </div>

    <div class="row">

      <div class="col-md-4 mb-3" v-if="content.toString().length > 3">
        <div class="card">
          <div class="card-body">
            <div class="d-flex flex-column align-items-center text-center">
              <img
                  src="https://image.freepik.com/darmowe-wektory/pszczelarz-w-stroju-ochronnym-stan-w-poblizu-ula_82574-5110.jpg"
                  alt="Admin" class="rounded-circle" width="150">

              <div class="mt-3" v-for="userdetail in content" v-bind:key="userdetail.id">
                <h4>{{ userdetail.beekeperName }} {{ userdetail.beekeperSurname }}</h4>
                <p class="text-secondary mb-1">{{ userdetail.email }}</p>
                <p class="text-muted font-size-sm">{{ userdetail.postCode }} {{ userdetail.city }} {{ userdetail.road }}
                  {{ userdetail.roadNr }}</p>
                <button class="btn btn-primary" v-on:click="editUserDetails(userdetail.id)">Edytuj swoje dane</button>
              </div>

              <button class="btn btn-secondary" v-on:click="changePassword()">Zmień hasło</button>
              <button class="btn btn-danger" v-on:click="deleteAccount()">Usuń konto</button>

            </div>
          </div>
        </div>
      </div>


      <div class="col-md-8">
        <div class="card mb-3">
          <div class="card-body">
            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Ilość Twoich pasiek: </h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ amountOfBeegardens }}
              </div>
            </div>
            <hr>
            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Ilość Twoich uli:</h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ amountOfBeehives }}
              </div>
            </div>
            <hr>
            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Ilość Twoich sensorów:</h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ amountOfSensors }}
              </div>
            </div>
            <hr>
<!--            <div class="row">-->
<!--              <div class="col-sm-3">-->
<!--                <h6 class="mb-0">Pogoda u Ciebie:</h6>-->
<!--              </div>-->
<!--              <div class="col-sm-9 text-secondary">-->
<!--                Pogoda-->
<!--              </div>-->
<!--            </div>-->
<!--            <hr>-->
            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Kalendarz pszczelarski:</h6>
              </div>
              <div class="col-sm-9 text-secondary">
                <a href="https://pasieka24.pl/images/stories/Aktualnosci/wiadomosci/2020/kalendarz-biodynamiczny_2020.jpg"
                   class="btn btn-secondary btn-lg active" role="button" aria-pressed="true">Link</a>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>


  </div>
</template>

<script>
import UserService from "@/services/user.service";

export default {
  name: 'Profile',
  data() {
    return {
      content: '',
      forecast: '',
      amountOfBeegardens: '',
      amountOfBeehives: '',
      amountOfSensors: ''
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      UserService.getUserBoard(this.currentUser.id).then(
          response => {
            this.content = response.data;
          },
          error => {
            this.content =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      UserService.getAmountOfBeegardens(this.currentUser.id).then(
          response => {
            this.amountOfBeegardens = response.data
          },
          error => {
            this.amountOfBeegardens =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      UserService.getAmountOfBeehives(this.currentUser.id).then(
          response => {
            this.amountOfBeehives = response.data
          },
          error => {
            this.amountOfBeehives =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      UserService.getAmountOfSensors(this.currentUser.id).then(
          response => {
            this.amountOfSensors = response.data
          },
          error => {
            this.amountOfSensors =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

  },
  methods: {

    editUserDetails(userDetailsId) {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else {
        this.$router.push('/edituserdetails?userDetailsId=' + userDetailsId);
      }
    },

    addUserDetails() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {
        this.$router.push('/adduserdetails');
      }
    },

    changePassword() {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else {
        this.$router.push('/changepassword');
      }
    },

    deleteAccount() {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else {
        if (confirm('Jesteś pewny, że chcesz usunąć swoje konto?'))
          UserService.deleteAccount(this.currentUser.id).then(
              response => {
                alert('Do zobaczenia przyjacielu!')
                this.content = response
                this.$store.dispatch('auth/logout');
                this.$router.push('/signup');
              },
              error => {
                this.content =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
              }
          );
      }
    },

  }
};
</script>

<style>
.card {
  box-shadow: 0 1px 3px 0 rgba(0, 0, 0, .1), 0 1px 2px 0 rgba(0, 0, 0, .06);
}

.card {
  position: relative;
  display: flex;
  flex-direction: column;
  min-width: 0;
  word-wrap: break-word;
  background-color: #fff;
  background-clip: border-box;
  border: 0 solid rgba(0, 0, 0, .125);
  border-radius: .25rem;
}

.card-body {
  flex: 1 1 auto;
  min-height: 1px;
  padding: 1rem;
}

.gutters-sm >, .gutters-sm > {
  padding-right: 8px;
  padding-left: 8px;
}

.mb-3 {
  margin-bottom: 1rem !important;
}

</style>